(function($) {
    var methods = {
        init: function(options) {
            var defaults = {
                message: "no message given",
                position: 'lef',
                backgroundColor: '#8F8F8F',
                borderColor: '7992B0',
                textColor: '#fff',
            };

            var options = $.extend(defaults, options);

            return this.each(function() {
                var o = options;
                var obj = $(this);
                var msg = o.message;
                var obj_position = obj.position();
                var containerDiv = $('<div class="callout">').append('<b class="notch"></b><b class="notchI"></b><div class="msg">' + msg+"</div>");
                containerDiv.css({
                    'background-color': o.backgroundColor,
                    'border-color': o.borderColor,
                    'color': o.textColor
                });
                
                
                // add by runbao
               
                    obj.before(containerDiv);
                    var setTop = obj_position.top - (containerDiv.height()) - 45;
                      //alert(setTop);
                    
                    if(setTop<0)
                    {
                    o.position="bottom"
                    }else
                    {
                    o.position="top"
                    }   /* */
                    
                    //test
                  //o.position="bottom"
                //
                
                 if(document.body.clientWidth>1024)
                 {
                    $(".msg").css('width','150px');
                  } else
                  {
                     if(document.body.clientWidth>450)
                {
                   $(".msg").css('max-width','450px');
                }else
                {
                   $(".msg").css('max-width',document.body.clientWidth/3*2+'px');
                }
                  }
                //var items = $("li", obj);
                switch (o.position) {
                case "bottom":
                    //obj.before(containerDiv);
                    var setLeft = obj_position.left + (obj.width() / 2) - (containerDiv.width() / 2) ;
                    
                    var setTop = obj_position.top + obj.height();
                     setLeft=   setLeft>0?setLeft:0;
                     
                     //
                    var x=document.body.offsetWidth- setLeft-containerDiv.width()- 20;
                    if(x<=0&&document.body.clientWidth<1024)
                    {
                      setLeft= document.body.clientWidth - containerDiv.width()-20;
                    }
                    //
                     
                    containerDiv.css({
                        'left': setLeft,
                        'top': setTop
                    });
                    $(".notch", containerDiv).css({
                        //'left': (containerDiv.width() / 2) - 5,
                        'left':obj_position.left-setLeft,
                        'border-bottom-color': o.borderColor
                    });
                    //
                    $("b.notchI", containerDiv).addClass('notch'); 
                   $(".notchI", containerDiv).css({
                        //'left': (containerDiv.width() / 2) - 5,
                        'left': obj_position.left-setLeft,
                        'top': -8 ,
                        'border-bottom-color': o.backgroundColor
                    });
                    //
                    break;
                case "right":
                    obj.after(containerDiv);
                    $("b.notch", containerDiv).addClass('notch_right').removeClass('notch');
                    var setLeft = obj_position.left + obj.width() + 15;
                    
                    var setTop = obj_position.top + (obj.height() / 2) - (containerDiv.height() / 2) - 10;
                    containerDiv.css({
                        'left': setLeft,
                        'top': setTop,
                        'margin': '0'
                    });
                    $(".notch_right", containerDiv).css({
                        'left': '-10px',
                        'top': (containerDiv.height() / 2) - 5,
                        'border-right-color': o.backgroundColor
                    });
                    break;
                case "top":
                    //obj.before(containerDiv);
                    $("b.notch", containerDiv).addClass('notch_top').removeClass('notch');
                    
                   // alert("left:"+obj_position.left+"|top:"+obj_position.top+"|width:"+obj.width()+"|height:"+obj.height()+"|containerDivHeight:"+containerDiv.height()+"|width"+containerDiv.width());
                    var setLeft = obj_position.left + (obj.width() / 2) - (containerDiv.width() / 2) ;
                    //
                    var x=document.body.offsetWidth- setLeft-containerDiv.width()-20;
                    if(x<=0&&document.body.clientWidth<1024)
                    {
                     setLeft= document.body.clientWidth - containerDiv.width()-20;
                     //alert(x+"|"+setLeft);
                    }
                    //
                    //alert(document.body.offsetWidth- setLeft-containerDiv.width());
                   
                    var setTop = obj_position.top - (containerDiv.height()) - 45;
                      setLeft=   setLeft>0?setLeft:0;
                    containerDiv.css({
                        'left':setLeft,
                        'top': setTop
                    }); /* */
                    $(".notch_top", containerDiv).css({
                        //'left': (containerDiv.width() / 2) - 5,
                        'left': obj_position.left-setLeft,
                        'top': containerDiv.height() + 10,
                        'border-top-color': o.borderColor
                    });
                    //
                    //
                   $("b.notchI", containerDiv).addClass('notch_top'); 
                   $(".notchI", containerDiv).css({
                        //'left': (containerDiv.width() / 2) - 5,
                        'left': obj_position.left-setLeft,
                        'top': containerDiv.height() + 10-2,
                        'border-top-color': o.backgroundColor
                    });
                    //
                    //
                    break;
                case "left":
                    obj.before(containerDiv);
                    $("b.notch", containerDiv).addClass('notch_left').removeClass('notch');
                    var setLeft = obj_position.left - containerDiv.width() - 25;
                    var setTop = obj_position.top + (obj.height() / 2) - (containerDiv.height() / 2) - 20;
                    containerDiv.css({
                        'left': setLeft,
                        'top': setTop
                    });
                    $(".notch_left", containerDiv).css({
                        'right': '-10px',
                        'top': (containerDiv.height() / 2) - 5,
                        'border-left-color': o.backgroundColor
                    });
                    break;
                }
                containerDiv.hide();
                containerDiv.fadeIn(300);
            });
        },
        hide: function() {
            return this.each(function(){
               $(this).parent().children('.callout').fadeOut(2000);
            })
        },
        show: function() {
            return this.each(function(){
               $(this).parent().children('.callout').fadeIn(2000);
            })            
        },        
        update: function(content) {}
    };

    $.fn.jCallout = function(method) {
        // Method calling logic
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.jCallout');
        }

    };

})(jQuery);

//
function initZhushi(){

//$(".msg").css('max-width',document.body.clientWidth/3*2+'px');


$(".zhushi").each(function(){
   // alert($(this).children().first().text());
   var text = $(this).contents().filter(function() {
return this.nodeType === 3;
}).text(); 
    var htmlstr= $(this).html().replace(text,'<img class="zimg" src="zhu.png"/>');
      //  htmlstr=htmlstr.replace(text,'<img class="zimg" src="play.png"/>');
    //alert(htmlstr);
    $(this).html(htmlstr);
    //alert($(this).text()) 
    // $("div").bind("click.plugin",function(){......});
     
      // $(this).click(function(event) {
       $(this).bind("click.plugin",function(event) {  
       $(".callout").css("display","none");     
     if($(this).prev().attr('class')=='callout' && $(this).prev().css("display")=="block")
     {
     //$(this).jCallout('hide');
       //alert($(this).prev().attr('class'));
      $(this).prev().hide();
     }else
     {
        if($(this).prev().css("display")=="none")
        {
             //$(this).jCallout('show');
             $(this).prev().show();
        }else
        {
        $(this).jCallout({
        message: $(this).find('b').html() ,
        position: "bottom" ,
        backgroundColor: "#fce66d",
        borderColor:"#ffa914",
        textColor: "#000000"
          });
        }
     }
      event.stopPropagation();
     //
    });
    //
  });
  
   var ua = navigator.userAgent,event = (ua.match(/iPad|iPhone|android/i)) ? "touchstart" : "click";
     //
      /*  */
    $("p").bind(event, function(e) {
    //do shit here
   
    if(e.target.tagName=="DIV")
    {
           return;
    }
       
    $(".callout").each(function(){
                	var display =$(this).css('display');
                        if(display == 'block'){
                             $(this).css("display","none");
                           }
                	});
        /* */         
});
 
/*
   $("p").click(function(){
             
                $(".callout").each(function(){
                	var display =$(this).css('display');
                        if(display == 'block'){
                             $(this).css("display","none");
                           }
                	});
                
        });*/
  //audio   
    var jpStr='<div id="jquery_jplayer_1" style="display:inline-block;"></div><div id="jp_container_1" style="display:inline-block;width:32px;"><a href="#" class="jp-play"><img class="zimg" src="play.png"/></a><a href="#" class="jp-pause"><img class="zimg" src="pause.png"/></a></div><div id="jplayer_inspector_1" class="jplayer_inspector" style="display:inline-block;"></div>';
	   $(".audio").each(function(index, element) {
		   
		   var newJp=jpStr.replace(/_1/g,"_"+index);
             //replace html div
			 $(this).replaceWith(newJp);
		     var mp3src=$(this).attr("src");			 
			 //add js control
		 $("#jquery_jplayer_"+index).jPlayer({
             ready: function () {
           $(this).jPlayer("setMedia", {
              mp3: mp3src
            });
          },
		   play: function() { // To avoid multiple jPlayers playing together.
			$(this).jPlayer("pauseOthers");
		},
         supplied: "mp3",
		  cssSelectorAncestor: "#jp_container_"+index
          });
		  $("#jplayer_inspector_"+index).jPlayerInspector({jPlayer:$("#jquery_jplayer_"+index)});
		  	/**/
		  //
		     
          });
		  
		 $(".jplayer_inspector").html('');
  //
   
}
  function stopAudio(){
       $(".jp-pause").click();
  }
function sizeZimg(fontsize){
           $(".zimg").height(fontsize);
}
function reZhu(){
      $(".zhushi").each(function(){
   
     $(this).unbind(".plugin");   //ɾ���ռ��ڵ��¼�
      if($(this).prev().attr('class')=='callout' )
     {
        $(this).prev().remove();
     }
    //alert($(this).text())  
      // $(this).click(function(event) {
      $(this).bind("click.plugin",function(event) {        
     if($(this).prev().attr('class')=='callout' && $(this).prev().css("display")=="block")
     {
     //$(this).jCallout('hide');
       //alert($(this).prev().attr('class'));
      $(this).prev().hide();
     }else
     {
     
        if($(this).prev().css("display")=="none")
        {
             //$(this).jCallout('show');
             $(this).prev().show();
        }else
        {
        $(this).jCallout({
        message: $(this).find('b').html() ,
        position: "bottom" ,
        backgroundColor: "#fce66d",
        borderColor:"#ffa914",
        textColor: "#000000"
          });
        }
     }
     
      event.stopPropagation();
     //
    });
    //
  });
}
//
function replaceSrc(str,dir){
var imgReg = /<(img|video).*?(?:>|\/>)/gi;
var srcReg = /src=['"]?([^'"]*)['"]?/i;
var arr = str.match(imgReg);
if(arr&&arr.length>0)
{
//alert('ff'+arr);
 var newsrc=new Array();
for (var i = 0; i < arr.length; i++) {
    var src = arr[i].match(srcReg); 
    if(src[1].indexOf("://")>0)
	{}else
	{ 
    if(src[1]&&newsrc.indexOf(src[1])==-1){
       newsrc.push(src[1]);   
         var oldsrc= src[1]; 
		 oldsrc=oldsrc.replace('(','\\(');
		 oldsrc=oldsrc.replace(')','\\)');  
		// altstr+=oldsrc+","; 
        str=str.replace(new RegExp(oldsrc,'gm'),dir+"/"+src[1]);
    }
    }  
  
}
}
return str;
}